Imports System.Data.OleDb

Module DbStuff
    ' Execute a non-query SQL statement.
    Public Sub ExecuteNonQuery(ByVal sql_statement As String)
        Dim db_conn As OleDbConnection = DatabaseConnection()
        Dim db_command As OleDbCommand

        ' Execute the command.
        db_command = New OleDbCommand( _
            sql_statement, db_conn)
        db_command.ExecuteNonQuery()

        db_conn.Close()
    End Sub

    ' Execute an INSERT statement and return the 
    ' auto-incremented field.
    Public Function ExecuteInsertStatement(ByVal insert_statement As String) As Long
        Dim db_conn As OleDbConnection = DatabaseConnection()
        Dim db_command As OleDbCommand
        Dim oldeb_adapter As New OleDbDataAdapter()
        Dim data_set As New DataSet()

        ' Execute the INSERT statement.
        db_command = New OleDbCommand( _
            insert_statement, db_conn)
        db_command.ExecuteNonQuery()

        ' Get the auto-incremented value.
        oldeb_adapter.SelectCommand = _
            New OleDbCommand("SELECT @@Identity", db_conn)
        oldeb_adapter.Fill(data_set)

        db_conn.Close()

        Return data_set.Tables(0).Rows(0).Item(0)
    End Function

    ' Execute a query and return the results.
    Public Function ExecuteQuery(ByVal query As String) As DataSet
        Dim db_conn As OleDbConnection = DatabaseConnection()
        Dim oldeb_adapter As New OleDbDataAdapter()
        Dim data_set As New DataSet()

        ' Execute the query and get a DataSet holding the results.
        oldeb_adapter.SelectCommand = _
            New OleDbCommand(query, db_conn)
        oldeb_adapter.Fill(data_set)

        db_conn.Close()
        Return data_set
    End Function

    ' Open and return a database connection.
    Private Function DatabaseConnection() As OleDbConnection
        Dim db_conn As New OleDbConnection(DatabaseConnectString())

        db_conn.Open()
        Return db_conn
    End Function

    ' Return the database connect string.
    Private Function DatabaseConnectString() As String
        Static connect_string As String

        If connect_string Is Nothing Then
            Dim db_name As String

            ' Get the database name. Start at 
            ' StartupPath, remove the \bin, and
            ' add the database name.
            db_name = Application.StartupPath
            db_name = db_name.Substring(0, db_name.LastIndexOf("\"))
            db_name = db_name & "\Personnel.mdb"

            ' Compose the connect string.
            connect_string = _
                "Provider=Microsoft.Jet.OLEDB.4.0;" & _
                "Data Source=" & _
                db_name
        End If

        Return connect_string
    End Function
End Module
